      subroutine remos
      include 'premos.inc'
c      parameter (nxprm=250,idsmax=2)
c                 remos82 main program
      common /ctorms0/ ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     *           ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax),job
c      common /ctorms3/ hwhm(2,idsmax),gamma(idsmax),uvw(2,idsmax),
c     *sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),p4(idsmax),as(idsmax)
      common /ctorms3/ hwhm(2,idsmax),rhwhm(idsmax),gamma(idsmax),
     * uvw(2,idsmax),sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),
     * p4(idsmax),as(idsmax)
      common /extcr/ nextnc,icef(7,48)
      dimension aa(10),bb(10),cc(10),ff(10),cm(3,3),om(3,3)
      common /extcr1/wv,abc0,cm,om,aa,bb,cc,ff,nbf,cef,cbt2,vol
      common /cdim/ idm,nde
      common /cwflag/ iwflag(7)
      integer dspmdl,tmpmdl,sctmdl
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
      common /cnsti/ ix,ib,if,itvr,itst,nds,na8,na9
      common /cnsto/ ix1,ix2,ix3,ix4,ix5,ix6,ix7,ix8,ix9,ix10,ix11,ix12
     *          ,ix13,ix14,ix15,ix16,ix17,ix18,ix19,ix20,ix21,ix22,
     *           ix23,ix24,ix25,ix26,ix27,ix28
      common /cnstt/ jx1,jx2,jx3
      common /citfs/ itfs(100)
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      integer hd1,hd2
      common /cpref/ hd1(6,48),hd2(6,48),iequ1,iequ2,pop,itype1,itype2
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      parameter (memmax=140000)
      dimension ax(memmax),tt0(6)
      integer ih(6)
c**********
      parameter (menmax=10000)
      character*4 bx(menmax)   !iw, mx, ifrt1 for titan
c**********
      integer defiwf(7)
      character*80 flnm1, flnm2, flnm3, flnm4
      character*4 watom
      data watom/'atom'/,tt0/6*0.0/
      data defiwf/0,1,1,4,2,3,0/
      data zmtrx /1,2,3,4,5,6,1,2,3,4,5,6,1,2,3,4,5,6/
c
c    memory design  (the large array, ax, are devided into 25 parts
c    and each part is used as a different array in several subroutines)
c  ax(na1):isft, ax(na2):mpl, ax(na3):x, ax(na4):isk,ax(na5):irs,
c  ax(na6);b,ax(na7):p,ax(na8):isub,ax(ix1):x1
c  ax(ix2):x2, ax(ix3):x3, ax(ix4):x4, ax(ix5):x5, ax(ix6):x6
c  ax(ix7):ea, ax(ix8):xjl, ax(ix9):bjl, ax(ix10):fjl, ax(ix11):csb
c  ax(ix12):m, ax(ix13):l, ax(ix14):ips, ax(ix15):ja, ax(ix16):iw
c  ax(ix17):cdr, ax(ix18):cdi, ax(ix19):xx, ax(ix20):mx, ax(ix21):ifrt1
c  ax(ix22):ifrt2, ax(ix23):coeff, ax(ix24):csb1, ax(ix25):csb2
c  ax(ix26):hl,ax(ix27):dl
c
c  bx(1):iw, bx(jx1):mx, bx(jx2):ifrt1   for titan
c
c dimension of ax
      call setinp(5)
      call setout(6)
      call setskp(0)
c calculation of sin cosin table
      call sctabl
c calculation of exp table
      call sexpt
c (0) read output control flags
c      read(5,'(7i1)') (iwflag(i),i=1,7)
      call freadi('iwflag=',7,iwflag,1)
      if(iwflag(1).eq.0) then
           do 10 i=1,7
 10        iwflag(i)=defiwf(i)
      end if
      write(6,'(1h ,a,7i3)') 'output control flags  ', iwflag
      read(5,'(a)') flnm1
      read(5,'(a)') flnm2
      read(5,'(a)') flnm3
      read(5,'(a)') flnm4
      lfn1=istrln(flnm1)
      lfn2=istrln(flnm2)
      lfn3=istrln(flnm3)
      lfn4=istrln(flnm4)
      write(6,'(1h ,a)') flnm1(1:lfn1)
      write(6,'(1h ,a)') flnm2(1:lfn2)
      write(6,'(1h ,a)') flnm3(1:lfn3)
      write(6,'(1h ,a)') flnm4(1:lfn4)
      open(unit=3,file=flnm1,status="UNKNOWN")
      open(unit=4,file=flnm2,status="UNKNOWN")
      open(unit=91,file=flnm3,access='direct',recl=1200,
     *     status="UNKNOWN")
      open(unit=92,file=flnm4,access='direct',recl=800,
     *     status="UNKNOWN")
c (1),(2) read title and lattice constants
      call rdlc
c (3) read number of atoms in an asymmetric unit
c      read(5,100) na
      call freadi('na=',1,na,1)
      call freadi('nsub=',1,nsub,0)
      if(nsub.le.0.or.nsub.gt.3) call quit('*** nsub invalid***')
      if(nsub.ge.2) then
          call freadi('zmtrx=',6,zmtrx(1,2),0)
      end if
      if(nsub.eq.3) then
          call freadi('zmtrx=',6,zmtrx(1,3),0)
      end if
      if(iwflag(3).eq.1) then
           write(6,*) 'na=',na,' nsub=',nsub,
     *        (' zmtrx=',(zmtrx(i,n),i=1,6),n=2,nsub)
      end if
      na1=1
      na2=na+na1
      na3=na+na2
      na4=6*na+na3
      na5=49*na+na4
      na6=49*na+na5
      na7=na+na6
      na8=na+na7
      na9=na+na8
c (4) read atomic positions
c     call rdap(na,isft,x,b,p,isub)
      call rdap(na,ax(na1),ax(na3),ax(na6),ax(na7),ax(na8))
c (5)-(10) read symmetry operators
c     call rdsymo(na,isk)
      call rdsymo(na,ax(na4))
      call getgij(zmtrx,nsub)
c     call btobij(na,ax(na6),ax(na8))
c     call sitesy(na,mpl,x,isk,irs,isub)
      call sitesy(na,ax(na2),ax(na3),ax(na4),ax(na5),ax(na8))
      call vicpy(hd1(1,1),ih,6)
      iequ1=multpl(ih,hd1(1,1))
      call vicpy(hd2(1,1),ih,6)
      iequ2=multpl(ih,hd2(1,1))
      write(6,*) 'iequ1=',iequ1,' iequ2=',iequ2
c (11) read control variables
c      read(5,100) ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,itvr,itst
c     *       ,nxmax
       call freadi('ix=',1,ix,1)
       call freadi('ib=',1,ib,0)
       call freadi('if=',1,if,0)
       call freadi('nds=',1,nds,0)
       call freadi('nzc=',1,nzc,0)
       call freadi('nw=',1,nw,0)
       call freadi('nt=',1,nt,0)
       call freadi('ipol=',1,ipol,0)
       call freadi('ipnf1=',1,ipnf1,0)
       call freadi('ipnf2=',1,ipnf2,0)
       call freadi('itvr=',1,itvr,0)
       call freadi('itst=',1,itst,0)
       call freadi('nxmax=',1,nxmax,0)
***************
      nds=0
***************
      if(nxmax.eq.0) nxmax=250
      if(iwflag(3).eq.1) then
           write(6,207) ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,itvr,
     *        itst,nxmax
      end if
c (12) read control variables
c      read(5,102) dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,isext
      call freadi('dspmdl=',1,dspmdl,1)
      call freadi('tmpmdl=',1,tmpmdl,0)
      call freadi('sctmdl=',1,sctmdl,0)
      call freadi('itempf=',1,itempf,0)
      call freadi('itwin=',1,itwin,0)
      call freadi('iphfl=',1,iphfl,0)
      call freadi('isext=',1,isext,0)
      if(iwflag(3).eq.1) then
           write(6,206) dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,isext
      end if
      call btobij(na,ax(na6),ax(na8))
c (13)
c     if(itempf.eq.2) read(5,103) (itfs(i),i=1,na)
      if(itempf.lt.0) read(5,103) (itfs(i),i=1,na)
      if(iwflag(3).eq.1) then
c          if(itempf.eq.2) write(6,201) (watom,i,itfs(i),i=1,na)
           if(itempf.lt.0) write(6,201) (watom,i,itfs(i),i=1,na)
      end if
      if(itwin.eq.0) volr(1)=1.0
c (14) read symmetry operators for twin
      if(itwin.ne.0) call rdtsym(itwin)
c (15)-(19) read atomic scattering factors
      do 500 id=1,ids
          call rdasf(sctmdl)
          call savasf(sctmdl,id)
 500  continue
c (20)-(21) read data for the second penalty function
      if(ipnf2.eq.1) call rdpnf2
c (22)-(26) read data for extinction correction
      if(isext.eq.1) then
          call rdextc
******************************************
c         wv=(wavl(1)*2+wavl(2))/3
******************************************
      end if
c calculations of constants
      call cnstnt(memmax,iax)
      if(jx3.gt.menmax) call quit('increase array size of bx')
      if(nx.gt.nxprm) then
          call quit('nx > nxprm')
      end if
      if(iax.gt.0) then
          write(6,200) iax
          call quit(' ')
      end if
c calculate intervals and weights in gauss integrals
      call gauss2
c (27) read fourier terms
c     call rdfour(nw,nt,ax(ix21),ax(ix22),ax(ix23))
      call rdfour(nw,nt,bx(jx2),ax(ix22),ax(ix23))
c calculate fourier terms for each independent atom
c     call begin(ax(ix11),nw,nt,na,nl,ax(na3),ax(na8),ax(ix21),
      call begin(ax(ix11),nw,nt,na,nl,ax(na3),ax(na8),bx(jx2),
     *      ax(ix22),ax(ix23),1,0,tt0)
c (28) read initial parameters x,b,p (na*ic*nw)
c (29)-(33) read constraint conditions
      nc=4+it
c     call rdintl(ax(ix19),ax(ix20),ax(ix15),ax(ix7),
      call rdintl(ax(ix19),bx(jx1),ax(ix15),ax(ix7),
     *                      ax(ix1),ax(na8),na,nc,nu)
c (34)-(42) read parameters for least squares calculations
      call fls(ax(ix15),ax(ix7),ax(ix8),ax(ix9),ax(ix10),
     *        ax(ix1),ax(ix2),ax(ix3),ax(ix14),ax(ix11),ax(ix12),
     *        ax(na1),ax(na8),ax(na2),ax(na3),ax(na6),ax(na7),
c    *        ax(ix16),ax(ix4),
     *        bx(1),ax(ix4),    !for titan
     *        ax(ix5),ax(ix6),ax(ix17),ax(ix18),ax(na4),ax(na5),
     *        ax(ix24),ax(ix25),ax(ix26),ax(ix27),
c    *        ax(ix21),ax(ix22),ax(ix23),nu)
     *        bx(jx2),ax(ix22),ax(ix23),nu)
************* plot powder diffraction pattern ***************
      return
 100  format(14i3)
 102  format(7i3)
 103  format(80i1)
 200  format(1h ,'lack of dimension',10x,'ax =',i6)
 201  format(1h ,'selection of temperature factors, 0: isotropic, 1: an
     *       isotropic'/(1h ,10(a4,i2,':',i1,2x)))
 206  format(1h ,'dspmdl=',i3,3x,'tmpmdl=',i3,3x,'sctmdl=',i3,3x,
     *      'itempf=',i3,3x,'itwin=',i3,3x,'iphfl=',i3,3x,'isext=',i3)
 207  format(1h ,'ix=',i3,2x,'ib=',i3,2x,'if=',i3,2x,'nds=',i3,2x,
     *      'nzc=',i3,2x,'nw=',i3,2x,'nt=',i3,2x,'ipol=',i3,2x,'ipnf1=',
     *    i3,2x,'ipnf2=',i3,2x,'itvr=',i3,2x,'itst=',i3,2x,'nxmax=',i3)
      end

      subroutine todrw(id)
c      common /ctodrw1/ qmint,qmaxt,dqt,ndatat,iwgt,mmaxt(3),wavlt(2),jbt
      common /ctodrw1/ qmint,qmaxt,dqt,istept,ndatat,iwgt,mmaxt(3),
     *     wavlt(2),jbt,ibkgrt
c      common /ctodrw3/ hwhmt(2),gammat,uvwt(2),p1t,p2t,p3t,p4t,ast,sgmt
      common /ctodrw3/ hwhmt(2),rhwhmt,gammat,uvwt(2),p1t,p2t,p3t,p4t,
     *  ast,sgmt
      real lenxt,lenyt
      common /ctodrw4/ lenxt,lenyt,hsclt,vsclt,deltat,ldevt,nrangt
      common /ctodrw6/ cpt(0:2),ppt(0:10),pgt
      common /ctodrw7/ iwlt,ixaxt,ilpt,alphat
      common /ctodrw8/ iptt(0:38),nlct
c      common /ctodrw9/ pbt(0:6), dpbt(6), zpst
      common /ctodrw9/ pbt(0:12), dpbt(12), zpst
      common /ctodrw0/ usrmnt(20),usrmxt(20)
      include 'premos.inc'
c     parameter (idsmax=2)
      common /ctorms0/ ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     *           ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax),job
c      common /ctorms3/ hwhm(2,idsmax),gamma(idsmax),uvw(2,idsmax),
c     *sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),p4(idsmax),as(idsmax)
      common /ctorms3/ hwhm(2,idsmax),rhwhm(idsmax),gamma(idsmax),
     * uvw(2,idsmax),sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),
     * p4(idsmax),as(idsmax)
      real lenx,leny
      common /ctorms4/ lenx(idsmax),leny(idsmax),hscl(idsmax),
     *    vscl(idsmax),delta(idsmax),ldev,nrange(idsmax)
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
      common /ctorms6/ cp(0:2,idsmax),pp(0:10,idsmax),pg(idsmax)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      common /cpwint/ ipt(0:38*idsmax),nlc
c      common /cbackg/ pb(0:6,idsmax), dpb(6,idsmax), zps(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(12,idsmax), zps(idsmax)
      common /crange/ usrmn(20,idsmax),usrmx(20,idsmax)
      npfx=21+6
      npfn=28+6
      qmint=qmin(id)
      qmaxt=qmax(id)
      dqt=dq(id)
      ndatat=ndata(id)
      wavlt(1)=wavl(1,id)
      wavlt(2)=wavl(2,id)
      jbt=job
      call getbgr(id,ibkgr)
      ibkgrt=ibkgr
      hwhmt(1)=hwhm(1,id)
      hwhmt(2)=hwhm(2,id)
      rhwhmt=rhwhm(id)
      gammat=gamma(id)
      uvwt(1)=uvw(1,id)
      uvwt(2)=uvw(2,id)
      p1t=p1(id)
      p2t=p2(id)
      p3t=p3(id)
      p4t=p4(id)
      ast=as(id)
      sgmt=sgm(id)
      lenxt=lenx(id)
      lenyt=leny(id)
      hsclt=hscl(id)
      vsclt=vscl(id)
      deltat=delta(id)
      ldevt=ldev
      nrangt=nrange(id)
      cpt(0)=cp(0,id)
      cpt(1)=cp(1,id)
      cpt(2)=cp(2,id)
      do 10 i=0,10
 10   ppt(i)=pp(i,id)
      pgt=pg(id)
      iwlt=iwl(id)
      ixaxt=ixax(id)
      ilpt=ilp(id)
      alphat=alpha(id)
      i0=0
      do 20 j=1,id-1
      if(iwl(j).le.8) then
          i0=i0+npfx
      else
          i0=i0+npfn
      end if
 20   continue
      if(iwl(id).le.8) then
         do 21 i=0,npfx-1
 21      iptt(i)=ipt(i+i0)
      else
         do 22 i=0,npfn-1
 22      iptt(i)=ipt(i+i0)
      end if
      i0=0
      do 23 j=1,ids
      if(iwl(j).le.8) then
          i0=i0+npfx
      else
          i0=i0+npfn
      end if
 23   continue
      i0=i0-1
      do 24 i=1,nlp
      if(iwl(id).le.8) then
          iptt(i+npfx-1)=ipt(i0+i)
      else
          iptt(i+npfn-1)=ipt(i0+i)
      end if
 24   continue
      nlct=nlc
c      do 30 i=0,6
      do 30 i=0,6+6
 30   pbt(i)=pb(i,id)
      zpst=zps(id)
      do 40 i=1,20
      usrmnt(i)=usrmn(i,id)
      usrmxt(i)=usrmx(i,id)
 40   continue
c      write(6,*) 'qmint,qmaxt,dqt,ndatat,iwgt,mmaxt(1),wavlt(1)',
c     *            qmint,qmaxt,dqt,ndatat,iwgt,mmaxt(1),wavlt(1)
c      write(6,*) 'hwhmt(1),gammat,uvwt(1),p1t,p2t,ast',
c     *            hwhmt(1),gammat,uvwt(1),p1t,p2t,ast
c      write(6,*) 'lenxt,lenyt,hsclt,vsclt,deltat,ldevt,nrangt',
c     *            lenxt,lenyt,hsclt,vsclt,deltat,ldevt,nrangt
c      write(6,*) 'cpt(0),ppt(0),pgt',cpt(0),ppt(0),pgt
c      write(6,*) 'iwlt,ixaxt,ilpt',iwlt,ixaxt,ilpt
c      write(6,*) 'iptt(0),nlct',iptt(0),nlct
c      write(6,*) 'pbt(0),zpst',pbt(0),zpst
c      write(6,*) 'usrmnt(1),usrmxt(1)',usrmnt(1),usrmxt(1)
      return
      end

      subroutine torms(id)
c      common /ctodrw1/ qmint,qmaxt,dqt,ndatat,iwgt,mmaxt(3),wavlt(2),jbt
      common /ctodrw1/ qmint,qmaxt,dqt,istept,ndatat,iwgt,mmaxt(3),
     *     wavlt(2),jbt,ibkgrt
      common /ctodrw3/ hwhmt(2),rhwhmt,gammat,uvwt(2),p1t,p2t,p3t,p4t,
     *  ast,sgmt
      real lenxt,lenyt
      common /ctodrw4/ lenxt,lenyt,hsclt,vsclt,deltat,ldevt,nrangt
      common /ctodrw6/ cpt(0:2),ppt(0:10),pgt
      common /ctodrw7/ iwlt,ixaxt,ilpt,alphat
      common /ctodrw8/ iptt(0:38),nlct
c     common /ctodrw9/ pbt(0:6), dpbt(6), zpst
      common /ctodrw9/ pbt(0:12), dpbt(12), zpst
      common /ctodrw0/ usrmnt(20),usrmxt(20)
      include 'premos.inc'
c     parameter (idsmax=2)
      common /ctorms0/ ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     *           ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax),job
c      common /ctorms3/ hwhm(2,idsmax),gamma(idsmax),uvw(2,idsmax),
c     *sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),p4(idsmax),as(idsmax)
      common /ctorms3/ hwhm(2,idsmax),rhwhm(idsmax),gamma(idsmax),
     * uvw(2,idsmax),sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),
     * p4(idsmax),as(idsmax)
      real lenx,leny
      common /ctorms4/ lenx(idsmax),leny(idsmax),hscl(idsmax),
     *    vscl(idsmax),delta(idsmax),ldev,nrange(idsmax)
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
      common /ctorms6/ cp(0:2,idsmax),pp(0:10,idsmax),pg(idsmax)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      common /cpwint/ ipt(0:38*idsmax),nlc
c     common /cbackg/ pb(0:6,idsmax), dpb(6,idsmax), zps(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(12,idsmax), zps(idsmax)
      common /crange/ usrmn(20,idsmax),usrmx(20,idsmax)
      npfx=21+6
      npfn=28+6
      qmin(id)=qmint
      qmax(id)=qmaxt
      dq(id)=dqt
      ndata(id)=ndatat
      wavl(1,id)=wavlt(1)
      wavl(2,id)=wavlt(2)
      job=jbt
      hwhm(1,id)=hwhmt(1)
      hwhm(2,id)=hwhmt(2)
      rhwhm(id)=rhwhmt
      gamma(id)=gammat
      uvw(1,id)=uvwt(1)
      uvw(2,id)=uvwt(2)
      p1(id)=p1t
      p2(id)=p2t
      p3(id)=p3t
      p4(id)=p4t
      as(id)=ast
      sgm(id)=sgmt
      lenx(id)=lenxt
      leny(id)=lenyt
      hscl(id)=hsclt
      vscl(id)=vsclt
      delta(id)=deltat
      ldev=ldevt
      nrange(id)=nrangt
      cp(0,id)=cpt(0)
      cp(1,id)=cpt(1)
      cp(2,id)=cpt(2)
      do 10 i=0,10
 10   pp(i,id)=ppt(i)
      pg(id)=pgt
      iwl(id)=iwlt
      ixax(id)=ixaxt
      ilp(id)=ilpt
      i0=0
      do 20 j=1,id-1
      if(iwl(j).le.8) then
          i0=i0+npfx
      else
          i0=i0+npfn
      end if
 20   continue
      if(iwl(id).le.8) then
         do 21 i=0,npfx-1
 21      ipt(i+i0)=iptt(i)
      else
         do 22 i=0,npfn-1
 22      ipt(i+i0)=iptt(i)
      end if
      i0=0
      do 23 j=1,ids
      if(iwl(j).le.8) then
          i0=i0+npfx
      else
          i0=i0+npfn
      end if
 23   continue
      i0=i0-1
      do 24 i=1,nlp
      if(iwl(id).le.8) then
          ipt(i0+i)=iptt(i+npfx-1)
      else
          ipt(i0+i)=iptt(i+npfn-1)
      end if
 24   continue
      nlc=nlct
c      do 30 i=0,6
      do 30 i=0,6+6
 30   pb(i,id)=pbt(i)
      zps(id)=zpst
      do 40 i=1,nrange(id)
      usrmn(i,id)=usrmnt(i)
      usrmx(i,id)=usrmxt(i)
 40   continue
      return
      end

      subroutine insert(deltd,md,delt,m,id,ij)
      real deltd(*),md(*),delt(*),m(*)
      include 'premos.inc'
c     parameter (idsmax=2)
      common /cpwint/ ipt(0:38*idsmax),nlc
      common /ctorms0/ ids
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      integer npp(0:idsmax),ipp(0:idsmax)
      npfx=21+6
      npfn=28+6
      npp(0)=0
      do 20 jd=1,ids
      if(iwl(jd).le.8) then
          npp(jd)=npp(jd-1)+npfx
      else
          npp(jd)=npp(jd-1)+npfn
      end if
 20   continue
      ipp(0)=0
      l=0
      do 21 jd=1,ids
      ipp(jd)=0
          do 22 k=npp(jd-1),npp(jd)-1
          l=l+1
          if(l.gt.npp(jd-1).and.l.le.npp(jd).and.ipt(k).eq.1) then
              ipp(jd)=ipp(jd)+1
          end if
 22       continue
      ipp(jd)=ipp(jd-1)+ipp(jd)
 21   continue
c     write(6,*) 'npp,ipp',npp,ipp
      k=0
      do 40 i=1,ij+nlc
      j0=i*(i-1)/2
      if(i.le.ij.or.(i-ij.gt.ipp(id-1).and.i-ij.le.ipp(id)).or.
     *    i-ij.gt.ipp(ids)) then
          k=k+1
          delt(i)=delt(i)+deltd(k)
          l=0
          k0=k*(k-1)/2
          do 41 j=1,i
          jk=j0+j
          if(j.le.ij.or.(j-ij.gt.ipp(id-1).and.j-ij.le.ipp(id)).or.
     *        j-ij.gt.ipp(ids)) then
              l=l+1
              lk=k0+l
              m(jk)=m(jk)+md(lk)
          end if
 41       continue
      end if
 40   continue
c      write(6,'(10f8.3)') (delt(j),j=1,ij+nlc)
c      do 999 i=1,ij+nlc
c      j0=i*(i-1)/2
c 999  write(6,'(10f8.3)') (m(j+j0),j=1,i)
      return
      end

      subroutine fls(ja,ea,xjl,bjl,fjl,x,y,z,ips,csb,
     *           m,isft,isub,mpl,xx,bx,px,iw,delt,de,df,cdr,cdi,isk,irs,
     *           csb1,csb2,hl,dl,ifrt1,ifrt2,coeff,nu)
      dimension ea(*),ja(*),xjl(*),bjl(*),fjl(*),ips(*),csb(*),isft(*)
      dimension isub(*)
      real m(*),mpl(*)
      dimension xx(*),bx(*),px(*),isk(*),irs(*)
      dimension csb1(*),csb2(*)
      dimension x(*),y(*),z(*),delt(*),de(*),df(*),cdr(*),cdi(*)
      dimension ifrt2(*),coeff(*),hl(*),dl(*)
      character*4 iw(*),ifrt1(*)
      include 'premos.inc'
c     parameter (nhkl=9999,nxprm=250,nmax=12000,idsmax=2)
      common /ctorms0/ ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     *           ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax),job
      common /ctorms2/ theta(nhkl),qe(3,nhkl),thbm,awl,fi
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
      common /cwflag/ iwflag(7)
c      common /cbackg/ pb(0:6,idsmax), dpb(6,idsmax), zps(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(12,idsmax), zps(idsmax)
      integer hkln
      complex fcal
      common /fhkl/ hkln(100),fobs(100),fcal(100),wght(100),im(20),is(2)
     *      ,sfcw
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      common /caydm/ aydm,alp,ifunc
      common /cpnf/ grad1,expn1,grad2,expn2,np
      common /cpwint/ ipt(0:38*idsmax),nlc
      common /cdim/ idm,nde
      integer dspmdl,tmpmdl,sctmdl
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      character*80 flnm0
      common /ctorms7 /flnm0(idsmax)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      common /cyo/ yo(nmax+2),qint(nmax+2)
      real rwp(idsmax),rwpt(idsmax)
      integer npt(0:idsmax)
c        23+15=38 ==> maximum number of profile and lattice parameters
      real md(nxprm*(nxprm+1)/2),deltd(nxprm),z1(nxprm)
      real sg(6,6),sg1(6,6)
      real*8 r,ro,rd,rw
      integer q

c
c     full matrix least squars method
c
c     read the number of blocks (block diagonal least squars method)
c      read(5,101) iextc
      call freadi('iextc=',1,iextc,1)
      write(6,*) 'iextc=',iextc
c**********************************************************************
c     initialization
c**********************************************************************
      pf1=0.0
      pf2=0.0
      ro=10.0d0
      pf1o=10.0
      pf2o=10.0
      totalo=10.0
      alc=0.1
      ncycle=0
c***********************************************************************
c     start of block loop
c***********************************************************************
      do 12 iz=1,iextc
c      read(5,105) iwf,fct
      call freadi('iwf=',1,iwf,1)
      call freadr('fct=',1,fct,0)
      if(iwflag(3).eq.1) then
           write(6,217) iwf,fct
      end if
      ie=1
c      read(5,102) ic,istdv,icont,ifunc,iwght
      call freadi('maxc=',1,ic,1)
      call freadi('istdv=',1,istdv,0)
      call freadi('icont=',1,icont,0)
      call freadi('ifunc=',1,ifunc,0)
      call freadi('iwght=',1,iwght,0)
c      read(5,103) eps,dmpf,aydm,alp,grad1,expn1,grad2,expn2
      call freadr('eps=',1,eps,1)
      call freadr('dmpf=',1,dmpf,0)
      call freadr('aydm=',1,aydm,0)
      call freadr('alph=',1,alp,0)
      call freadr('grad1=',1,grad1,0)
      call freadr('expn1=',1,expn1,0)
      call freadr('grad2=',1,grad2,0)
      call freadr('expn2=',1,expn2,0)
      dmp=dmpf
      if(aydm.eq.0.0) aydm=5.0
      if(iwflag(3).eq.1) then
            write(6,206) ic,istdv,icont,ifunc,iwght,eps,dmpf,aydm,alp
     *             ,grad1,expn1,grad2,expn2
      end if
c     nx:  upper limit of the total number of parameters
c     ny : number of structural parameters treated in remos
c     nz+1 : number of other parameters
c     nlp: number of lattice parameters
      npfx=21+6
      npfn=28+6
      nz=nlp-1
      npt(0)=0
      do 500 id=1,ids
         if(iwl(id).le.8) then
            npt(id)=npfx
         else if(iwl(id).eq.9) then
            npt(id)=npfn
         end if
         nz=nz+npt(id)
 500  continue
      call rdiob0(iwght)
      ny=nu
      read(5,104) (ips(k),k=1,ny)
      read(5,104) (ipt(k),k=0,nz)
c       0: scale factor
c     1-6: background parameters                   
c     7  : asymmetric parameter
c     8,9: u and v of the theta dependence of hwhm 
c     10 : ratio of gauss component                
c     11,12: hwhm of gauss and lorentz functions   
c     13 :   rhwhm
c     14 : absorption parameter
c     15 : extinction parameter
c     16-19: prefered orientation parameters       
c     20 : zero point shift
c     21-: lattice parameters                      

c     count the number of variable parameters (ij)
      ij=0
      do 73 j=1,ny
         if(ips(j).eq.0) go to 73
         ij=ij+1
 73   continue
      nlc=0
      do 74 j=0,nz
         if(ipt(j).eq.0) go to 74
         nlc=nlc+1
 74   continue
c     check whether ij exceeds nxmax or not

      if(ij+nlc.gt.nxmax) then
c ****** input error
            write(6,213) iz,ij+nlc
            call quit(' ')
c ******
      end if
      do j=1,ny
         iw(j)=' '
         if(ips(j).eq.0) iw(j)='*'
      end do
      do j=0,nz
         iw(ny+j+1)=' '
         if(ipt(j).eq.0) iw(ny+j+1)='*'
      end do
c*********************************************************************
c     start of least squars loop
c*********************************************************************
      do 50 nn=0,ic
      ncycle=ncycle+1
      call imddlt(m,delt,ij+nlc)
c      do 31 j=1,ij+nlc
c 31   delt(j)=0.0
c      jk=0
c      do 32 j=1,ij+nlc
c      do 32 k=1,j
c      jk=jk+1
c 32   m(jk)=0.0
      if(ncycle.eq.1) then
          if(icont.eq.1) then
              rewind 4
              read(4,212) (x(j),j=1,ny+nz+1)
              do 321 j=1,ny+nz+1
 321          df(j)=0
c             set profile parameters
              call wtmtrt(x(ny+1))
          else
c             set x
              call rdmtrt(x(ny+1))
              do 322 j=1,ny+nz+1
 322          df(j)=0
          end if
      end if
c      get metric temsor and wave vector from parameter x
c
      write(6,*) '************'
      write(6,209) ncycle
      write(6,*) '************'
      if(iwflag(4).eq.4) then
c****   write initial fourier amplitudes
           if(ncycle.eq.1) then
               write(6,216) '(u,v,w,bi:10**5, b,p:10**3)'
     *                ,' (----) denotes a fixed parameter'
c              call prmtbl(x,df,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,it,nl,1)
               call prmtbl(x,df,isub,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,
     *              it,nl,1)
               write(6,202)
               call wtltcc(x(ny+1),df(ny+1))
           end if
      else
           if(iwflag(4).eq.1.or.iwflag(4).eq.3) then
c*****   output fourier amplitudes in each cycle
               write(6,218) '(u,v,w,bi:10**5, b,p:10**3)'
     *                ,' (----) denotes a fixed parameter'
c               call prmtbl(x,df,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,it,nl,1)      
               call prmtbl(x,df,isub,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,
     *              it,nl,1)      
               write(6,202)
               call wtltcc(x(ny+1),df(ny+1))
           end if
      end if
      if(iwflag(5).eq.1.or.iwflag(5).eq.3) then
c*****   output independent parameters in each cycle
           write(6,211)
           call wx(x,ny+nz+1,iw)
      end if
      if(iwflag(5).eq.2.or.iwflag(5).eq.3) then
c****    output their difference in each cycle
          if(nn.ne.0) then
               write(6,214)
               call wx(df,ny+nz+1,iw)
          end if
      end if
      rewind 4
      write(4,212) (x(j),j=1,ny+nz+1)
c     calculate xjl,bjl,fjl
      call egvctr(x,ja,ea,nu,nzc,xjl,bjl,fjl,csb,it,nw,na,nl,
     *                  xx,bx,px,isub)
c     calculate penalty function
      if(ipnf1.gt.0) call pnf1(pf1,delt,df,fjl,ja,ea,csb,
     *       m,ie,ips,x,ij,nw,na,nu)
      if(ipnf2.eq.1) call pnf2(pf2,delt,hl,ja,ea,csb1,csb2,
     *       m,ie,ips,x,ij,xx,isub,ifrt1,ifrt2,coeff,dl,nw,nu)
c     calculate structure factors
 700  continue
      rwpa2=0
      rwpta2=0
      ntdata=0
      is(2)=0
      nnnn=0
******************
      do 510 id=1,ids
c         get hklm and mpl
          call gethkl(nfcal,id)
          call rdiob1(iwght)
          call getasf(sctmdl,id)
          call stfc(x,m,delt,de,df,r,rd,rw,ips,ie,ja,ea,xjl,bjl,fjl,
     *          csb,isft,isub,mpl,ij,z,isk,irs,cdr,cdi,it,nw,na,nu)
          thbm=thbmd(id)
          fi=fid(id)
          awl=(2*wavl(1,id)+wavl(2,id))/3
          open(unit=2,file=flnm0(id),status="UNKNOWN")
          if(job.eq.0.or.job.eq.2) then
              call rdyo(yo,qint,ndata(id))
              if(ndata(id).gt.nmax) then
                  call quit('ndata > nmax')
              end if
          end if
          call todrw(id)
          call rdhkl(nfcal)
          is(2)=is(2)+nfcal
          nnnn=nnnn+nfcal
          call imddlt(md,deltd,ij+nlc)
          call drwpdf(nfcal,md,deltd,rwp(id),rwpt(id))
          call insert(deltd,md,delt,m,id,ij)
          rwpa2=rwpa2+rwp(id)**2
          rwpta2=rwpta2+rwpt(id)**2
          call torms(id)
          close(unit=2)
          if(job.eq.1.or.nn.eq.ic) then
              call testout(nfcal)
          end if
          ntdata=ntdata+ndata(id)
 510  continue
      if(job.ne.0) then
          call getzap()
          call quit(' ')
      end if
c      set scale and background
      call rdmtrt(x(ny+1))
******************
      chisqr=rwpa2+pf1**2+pf2**2
      rwpa=sqrt(rwpa2/ids)
      rwpta=sqrt(rwpta2/ids)
      total=sqrt(chisqr)
      write(6,*) '************'
      write(6,201) ncycle,rwpa,rwpta,pf1,pf2,total
      write(6,*) '************'
      if(ids.gt.1) then
          do 520 id=1,ids
          write(6,'(1h ,a,i2,2(a,f8.4))')
     *    ' data set',id,' rwp=',rwp(id),' rwpt=',rwpt(id)
 520      continue
      end if
      do 401 j=1,ny+nz+1
 401  y(j)=x(j)
c     stop conditions

      if((nn.eq.ic.and.iz.eq.iextc).or.abs(total-totalo).lt.eps
     *       .or.ij+nlc.eq.0) then
           istop=1
      else
           istop=0
      end if
      rwpo=rwpa
      pf1o=pf1
      pf2o=pf2
      totalo=total
c     calculations of new parameters
      q=0
      if(iwflag(7).eq.1) q=1
      if(istop.eq.1.and.abs(istdv).eq.1) then
          q=1
          dmp=0.0
      end if
      if(ij+nlc.eq.0) go to 60
c     solve the normal equation
********************
      call chlsk(m,delt,de,ij+nlc,q,ising,dmp,df)
********************
      if(iwflag(7).eq.1) then
           call corrm(m,delt,ij+nlc)
      end if
      if(ising.eq.1) then
            call quit(' ')
      end if
      do 403 j=1,ny+nz+1
 403  x(j)=y(j)
      if(ipol.eq.1) call txr(x)
      k=0
      do 404 j=1,ny
      if(ips(j).eq.1) then
          k=k+1
          x(j)=x(j)+de(k)
      end if
 404  continue
      if(istop.eq.1.and.abs(istdv).eq.1) go to 60
      do 405 j0=0,nz
      j=j0+ny+1
      if(ipt(j0).eq.1) then
          k=k+1
          x(j)=x(j)+de(k)
      end if
 405  continue
c      set profile parameters
      call wtmtrt(x(ny+1))
c      set positive asymmetry parameter and gamma
      call rdmtrt(x(ny+1))
c
      if(ipol.eq.1) call trx(x)
c     calculate differences
      do 41 j=1,ny+nz+1
 41   df(j)=x(j)-y(j)
      if(istop.eq.1) go to 60
 50   continue
c*********************************************************************
c     end of least squars loop
c*********************************************************************
 60   continue
      if(istop.eq.1.and.abs(istdv).eq.1.and.ij+nlc.gt.0) then
c         calculate standard deviations
          do 71 j=1,ny+nz+1
c          z1(j)=0.0
 71       z(j)=0.0
          k=0
          kk=0
c          nnnn=is(2)
c          if(ipnf1.eq.1) nnnn=nnnn+na*nl
c          if(ipnf2.eq.1) nnnn=nnnn+np*nl
c         fstdv : chisquare per nnnn reflections
          fstdv=chisqr*nnnn/ntdata
          do 701 j=1,ny
          if(ips(j).eq.0) go to 701
              k=k+1
              kk=kk+k 
c             z(j)=sqrt(fstdv*m(kk)/(nnnn-ij-nlc))
c             z(j)=sqrt(rwpa2*m(kk)/(ntdata-nlc-nlc))
              z(j)=sqrt(rwpa2*m(kk)/(nnnn-ij))
c              z1(j)=sqrt(rwpa2*m(kk)/(nnnn-ij-nlc))
 701      continue
c         do 702 j=0,nz-nlp
          do 702 j=0,nz
          if(ipt(j).eq.0) go to 702
              k=k+1
              kk=kk+k
c             z(ny+1+j)=sqrt(fstdv*m(kk)/(nnnn-ij-nlc))
c             z(ny+1+j)=sqrt(rwpa2*m(kk)/(ntdata-ij-nlc))
              z(ny+1+j)=sqrt(rwpa2*m(kk)/(nnnn-ij))
c              z1(ny+1+j)=sqrt(rwpa2*m(kk)/(nnnn-ij-nlc))
 702      continue
      end if
      if(istop.eq.1.and.abs(istdv).ne.1) then
c ***** starting point of the next cycle
           if(iwflag(4).ge.1.and.iwflag(4).le.4.or.
     *        iwflag(5).ge.1.and.iwflag(5).le.3) then
                write(6,210)
           end if
           if(iwflag(4).eq.1.or.iwflag(4).eq.3) then
c*****     fourier amplitudes of the next cycle
               write(6,218) '(u,v,w,bi:10**5, b,p:10**3)'
     *                ,' (----) denotes a fixed parameter'
c               call prmtbl(x,df,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,it,nl,1)
               call prmtbl(x,df,isub,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,
     *              it,nl,1)
               write(6,202)
               call wtltcc(x(ny+1),df(ny+1))
           end if
          if(iwflag(5).eq.1.or.iwflag(5).eq.3) then
c*****     parameters of the next cycle
               write(6,211)
               call wx(x,ny+nz+1,iw)
           end if
           if(iwflag(5).eq.2.or.iwflag(5).eq.3) then
c*****     output their difference from the previous ones
               write(6,214)
               call wx(df,ny+nz+1,iw)
           end if
           rewind 4
           write(4,212) (x(j),j=1,ny+nz+1)
      end if
c *******
           if(istdv.eq.-1) then
              write(6,*) 'variant matrix (lower triangular part)'
              do k=1,ij+nlc
                 kk=(k-1)*k/2
                 write(6,'(10e12.4)') (rwpa2*m(j)/(nnnn-ij),j=kk+1,kk+k)
              end do
           end if
 12   continue
c**********************************************************************
c     end of block loop
c**********************************************************************
      if(iwflag(4).eq.4.and.abs(istdv).ne.1) then
c****   write final fourier amplitudes
           write(6,207) '(u,v,w,bi:10**5, b,p:10**3)'
     *                ,' (----) denotes a fixed parameter'
c           call prmtbl(x,df,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,it,nl,1)
           call prmtbl(x,df,isub,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,
     *          it,nl,1)
           write(6,202)
           call wtltcc(x(ny+1),df(ny+1))
      end if
c***** output standard dev. of independent parameters
*******************************************************************
      if(abs(istdv).eq.1.and.ij+nlc.gt.0) then
          ll=ij*(ij+1)/2
          nsk=0
          do 530 id=0,nz-nlp
              if(ipt(id).eq.1) nsk=nsk+1
 530      continue
c        nsk: number of variable profile parameters excluding lattice param.
          do 501 id=ij+1,ij+nlc
          do 501 jd=1,id
          ll=ll+1
          ii=id-ij-nsk
          jj=jd-ij-nsk
          if(ii.ge.1.and.ii.le.6.and.jj.ge.1.and.jj.le.6) then
c             sg(ii,jj)=fstdv*m(ll)/(nnnn-ij-nlc)
c             sg(jj,ii)=sg(ii,jj)
              sg(ii,jj)=rwpa2*m(ll)/(ntdata-ij-nlc)
              sg(jj,ii)=sg(ii,jj)
              sg1(ii,jj)=rwpa2*m(ll)/(nnnn-ij-nlc)
              sg1(jj,ii)=sg1(ii,jj)
          end if
 501      continue
          if(iwflag(6).eq.1.or.iwflag(6).eq.3) then
               write(6,203)
               call wx(z,ny+nz+1,iw)
c               call wx(z1,ny+nz+1,iw)
          end if
*******************************************************************
c ******  output standard dev. of fourier amplitudes
          if(iwflag(6).eq.2.or.iwflag(6).eq.3) then
               write(6,208) '(u,v,w,bi:10**5, b,p:10**3)'
     *                ,' (----) denotes a fixed parameter'
c               call prmtbl(y,z,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,it,nl,2)
               call prmtbl(y,z,isub,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,
     *              it,nl,2)
c               call wtltcc(y(ny+1),z(ny+1))
c               call wtlcsd(z(ny+nz+1-nlp),sg)
               call wtlcsd(y(ny+1),z(ny+1),sg)
c               write(6,208) '(u,v,w,bi:10**5, b,p:10**3)'
c     *                ,' (----) denotes a fixed parameter'
cc               call prmtbl(y,z1,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,it,nl,2)
c               call prmtbl(y,z1,isub,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,
c     *        it,nl,2)
c               call wtltcc(y(ny+1),z1(ny+1))
c               call wtlcsd(z1(ny+nz+1-nlp),sg1)
c               call wtlcsd(y(ny+1),z1(ny+1),sg1)
          end if
      end if
c *****   output structure factors
c      write(6,202)
c      call wtfhkl(fct,iwf,y)
      return
 101  format(i3)
 102  format(6i3)
 103  format(8f10.6)
 104  format(80i1)
 105  format(i3,f12.6)
 201  format(1h ,'cycle ',i3,2x,'rwp=',f7.4,2x,'rwpt=',f7.4,
     *    2x,'pf1=',f7.4,2x,'pf2=',f7.4,2x,
     *    'sqrt(rwp**2+pf1**2+pf2**2)=',f9.6)
 202  format(1h1)
 203  format(1h ,'standard deviation')
 206  format(1h , 'maximum cycles', 3x,i3,5x,
     *      'istdv=',i3,3x,'icont=',i3,3x,'ifunc=',i3,3x,
     *      'wght=',i3/1h ,'eps=',2x,f9.6,2x,
     *      'dmpf=',2x,f7.4,2x,'aydm=',2x,f7.4,2x,
     *      'alp=',f7.4,2x,'grad1=',f7.4,2x,'expn1=',f7.4,2x,
     *      'grad2=',f7.4,2x,'expn2=',f7.4)
 207  format(1h ,'final fourier amplitudes  ',2a)
 208  format(1h ,'final fourier amplitudes and their stdv ',2a)
 209  format(1h ,'cycle',i3)
 210  format(1h ,'next cycle')
 211  format(1h ,'independent parametes (fixed parameters asterisked)')
 212  format(8e14.6)
 213  format(1h ,'number of variable parameters exceeded nxmax'/1h ,
     *                    'extc=',i2,3x,i5,1x,'parameters')
 214  format(1h ,'difference')
 215  format(1h ,'damping factor .gt.10       dmp=',f10.4)
 216  format(1h ,'initial fourier amplitudes  ',2a)
 217  format(1h ,'iwf=',i3,2x,'fct=',f12.6)
 218  format(1h ,'fourier amplitudes ',2a)
 219  format(1h ,'differences of fourier amplitudes ',2a)
      end

      subroutine imddlt(md,deltd,ij)
      real md(*),deltd(*)
      do 511 j=1,ij
 511  deltd(j)=0.0
      jk=0
      do 512 j=1,ij
      do 512 k=1,j
      jk=jk+1
 512  md(jk)=0.0
      return
      end

      subroutine testout(nfcal)
      include 'premos.inc'
c     parameter (nhkl=9999,idsmax=2)
      complex fc
      real qs
      integer hklm,mpl
      common /chklfm/ hklm(6,nhkl),qs(nhkl),mpl(nhkl),fc(nhkl)
      common /cdim/ idm,nde
      common /ctorms2/ theta(nhkl),qe(3,nhkl),thbm,awl,fi
c      common /ctodrw3/ hwhm(2),gamma,uvw(2),p1,p2,p3,p4,as,sgm
      common /ctodrw3/ hwhm(2),rhwhm,gamma,uvw(2),p1,p2,p3,p4,as,sgm
      common /ctodrw7/ iwl,ixax,ilp,alpha
      real dpof(4),lp
      integer ns,st
      common /cqsort/ ns(nhkl),st(nhkl,2)
      character*40 frmt
      data pi2/ 6.28318/
      fact=pi2/360
      if(idm.eq.3) then
          write(frmt,'(a)') '(3i3,i4,6f11.5)'
          write(6,'(3a)') '  indices  mpl',
     *         '     fc      2-theta        Q         d         lp',
     *                                    '          pof'
      else if(idm.eq.4) then
          write(frmt,'(a)') '(4i3,i4,6f11.5)'
          write(6,'(3a)') '  indices     mpl',
     *         '     fc      2-theta        Q         d         lp',
     *                                    '          pof'
      else if(idm.eq.5) then
          write(frmt,'(a)') '(5i3,i4,6f11.5)'
          write(6,'(3a)') '  indices        mpl',
     *         '     fc      2-theta        Q         d         lp',
     *                                    '          pof'
      else if(idm.eq.6) then
          write(frmt,'(a)') '(6i3,i4,6f11.5)'
          write(6,'(3a)') '  indices           mpl',
     *         '     fc      2-theta        Q         d         lp',
     *                                    '          pof'
      end if
      do 100 ii=1,nfcal
          i=ns(ii)
          if(iwl.le.8) then
              lp=flp(theta(i)*fact)
          else
              lp=flp(qs(i))
          end if
          pof=poffct(qe(1,i),p1,p2,p3,p4,dpof)
          write(6,frmt) (hklm(j,i),j=1,idm),mpl(i),
     *          abs(fc(i)),theta(i),qs(i)*pi2,1/qs(i),lp,pof
 100  continue
      return
      end

      subroutine corrm(m,d,n)
      real m(*),d(*)
      k=0
      do 100 i=1,n
      d(i)=sqrt(m(i*(i+1)/2))
 100  continue
      do 110 i=1,n
      do 110 j=1,i
      k=k+1
      m(k)=m(k)/(d(i)*d(j))
 110  continue
      do 120 i=1,n
      write(6,'(1h ,20f6.2)') (m(i*(i-1)/2+j),j=1,i)
 120  continue
      return
      end

      subroutine rdmtrt(x)
      real x(*)
      include 'premos.inc'
c     parameter (idsmax=2)
      common /ctorms0/ ids
c      common /ctorms3/ hwhm(2,idsmax),gamma(idsmax),uvw(2,idsmax),
c     *sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),p4(idsmax),as(idsmax)
      common /ctorms3/ hwhm(2,idsmax),rhwhm(idsmax),gamma(idsmax),
     * uvw(2,idsmax),sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),
     * p4(idsmax),as(idsmax)
      common /ctorms6/ cp(0:2,idsmax),pp(0:10,idsmax),pg(idsmax)
c      common /cbackg/ pb(0:6,idsmax), dpb(6,idsmax), zps(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(12,idsmax), zps(idsmax)
      common /cpwint/ ipt(0:38*idsmax),nlc
      common /kwave/ y(3,3,3),vc(3)
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      integer js(15),ks(15)
      real abccos(6)
      data js/1,2,3,2,1,1,1,1,1,2,2,2,3,3,3/
      data ks/1,2,3,3,3,2,1,2,3,1,2,3,1,2,3/
      npfx=21+6
      npfn=28+6
      l=0
      do 500 id=1,ids
      if(iwl(id).le.8) then
          do 321 i=0,npfx-1
          l=l+1
          if(i.ge.0.and.i.le.6+6) then
               x(l)= pb(i,id)
          else if(i.eq.7+6) then
               if(as(id).gt.0) then
                   x(l)=as(id)
               else
                   x(l)=0
               end if
          else if(i.ge.8+6.and.i.le.9+6) then
               x(l)=uvw(i-7-6,id)
          else if(i.eq.10+6) then
               if(gamma(id).gt.0) then
                   x(l)=gamma(id)
               else
                   x(l)=0.00001
               end if
          else if(i.ge.11+6.and.i.le.12+6) then
               if(hwhm(i-10-6,id).gt.0) then
                   x(l)=hwhm(i-10-6,id)
               else
                   x(l)=0.00001
               end if
          else if(i.eq.13+6) then
               x(l)=rhwhm(id)
          else if(i.eq.14+6) then
               x(l)=sgm(id)
          else if(i.eq.15+6) then
               x(l)=pg(id)
          else if(i.eq.16+6) then
               x(l)=p1(id)
          else if(i.eq.17+6) then
               x(l)=p2(id)
          else if(i.eq.18+6) then
               x(l)=p3(id)
          else if(i.eq.19+6) then
               x(l)=p4(id)
          else if(i.eq.20+6) then
               x(l)=zps(id)
          end if
 321      continue
      else
          do 322 i=0,npfn-1
          l=l+1
          if(i.ge.0.and.i.le.6+6) then
              x(l)=pb(i,id)
          else if(i.ge.7+6.and.i.le.17+6) then
              x(l)=pp(i-7-6,id)
          else if(i.eq.18+6) then
              x(l)=rhwhm(id)
          else if(i.eq.19+6) then
              x(l)=sgm(id)
          else if(i.eq.20+6) then
              x(l)=pg(id)
          else if(i.eq.21+6) then
              x(l)=p1(id)
          else if(i.eq.22+6) then
              x(l)=p2(id)
          else if(i.eq.23+6) then
              x(l)=p3(id)
          else if(i.eq.24+6) then
              x(l)=p4(id)
          else if(i.ge.25+6.and.i.le.27+6) then
              x(l)=cp(i-25-6,id)
          end if
 322      continue
      end if
 500  continue
      call getabc(gabn,abccos)
      do 33 l1=1,nlp
          l=l+1
          do 34 l2=1,1
          l0=il(l2,l1)
          j=js(l0)
          k=ks(l0)
          if(l0.le.6) then
c             x(l)=gabn(j,k)/cl(l2,l1)
              x(l)=abccos(l0)/cl(l2,l1)
          else
              x(l)=y(k,j,1)/cl(l2,l1)
          end if
 34       continue
 33   continue
      return
      end

      subroutine wtmtrt(x)
      real x(*)
      include 'premos.inc'
c     parameter (idsmax=2)
      common /ctorms0/ ids
c      common /ctorms3/ hwhm(2,idsmax),gamma(idsmax),uvw(2,idsmax),
c     *sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),p4(idsmax),as(idsmax)
      common /ctorms3/ hwhm(2,idsmax),rhwhm(idsmax),gamma(idsmax),
     * uvw(2,idsmax),sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),
     * p4(idsmax),as(idsmax)
      common /ctorms6/ cp(0:2,idsmax),pp(0:10,idsmax),pg(idsmax)
c      common /cbackg/ pb(0:6,idsmax), dpb(6,idsmax), zps(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(12,idsmax), zps(idsmax)
      common /cdim/ idm,nde
      common /kwave/ y(3,3,3),vc(3)
      common /cpwint/ ipt(0:38*idsmax),nlc
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      integer js(15),ks(15),nl0(15)
      real abccos(6)
      data js/1,2,3,2,1,1,1,1,1,2,2,2,3,3,3/
      data ks/1,2,3,3,3,2,1,2,3,1,2,3,1,2,3/
      npfx=21+6
      npfn=28+6
      call getabc(gabn(1,1,1),abccos)
      l=0
      do 500 id=1,ids
      if(iwl(id).le.8) then
          do 341 i=0,npfx-1
          l=l+1
          if(i.ge.0.and.i.le.6+6) then
              pb(i,id)=x(l)
          else if(i.eq.7+6) then
              if(x(l).gt.0) then
                  as(id)=x(l)
              else
                  as(id)=0
              end if
          else if(i.ge.8+6.and.i.le.9+6) then
              uvw(i-7-6,id)=x(l)
          else if(i.eq.10+6) then
              if(x(l).gt.0) then
                  gamma(id)=x(l)
              else
                  gamma(id)=0.00001
              end if
          else if(i.ge.11+6.and.i.le.12+6) then
              if(x(l).gt.0) then
                  hwhm(i-10-6,id)=x(l)
              else
                  hwhm(i-10-6,id)=0.00001
              end if
          else if(i.eq.13+6) then
              rhwhm(id)=x(l)
          else if(i.eq.14+6) then
              sgm(id)=x(l)
          else if(i.eq.15+6) then
              pg(id)=x(l)
          else if(i.eq.16+6) then
              p1(id)=x(l)
          else if(i.eq.17+6) then
              p2(id)=x(l)
          else if(i.eq.18+6) then
              p3(id)=x(l)
          else if(i.eq.19+6) then
              p4(id)=x(l)
          else if(i.eq.20+6) then
              zps(id)=x(l)
          end if
 341      continue
      else
          do 322 i=0,npfn-1
          l=l+1
          if(i.ge.0.and.i.le.6+6) then
              pb(i,id)=x(l)
          else if(i.ge.7+6.and.i.le.17+6) then
              pp(i-7-6,id)=x(l)
          else if(i.eq.18+6) then
              rhwhm(id)=x(l)
          else if(i.eq.19+6) then
              sgm(id)=x(l)
          else if(i.eq.20+6) then
              pg(id)=x(l)
          else if(i.eq.21+6) then
              p1(id)=x(l)
          else if(i.eq.22+6) then
              p2(id)=x(l)
          else if(i.eq.23+6) then
              p3(id)=x(l)
          else if(i.eq.24+6) then
              p4(id)=x(l)
          else if(i.ge.25+6.and.i.le.27+6) then
              cp(i-25-6,id)=x(l)
          end if
 322      continue
      end if
 500  continue
      do 44 j=1,15
          nl0(j)=0
 44    continue
      do 43 l1=1,nlp
      l=l+1
          do 45 l2=1,ntl(l1)
          l0=il(l2,l1)
          nl0(l0)=nl0(l0)+1
          j=js(l0)
          k=ks(l0)
          if(l0.le.6) then
              if(nl0(l0).eq.1) then
                  abccos(l0)=x(l)*cl(l2,l1)
              else
                  abccos(l0)=abccos(l0)+x(l)*cl(l2,l1)
              end if
          else
              if(nl0(l0).eq.1) then
                  y(k,j,1)=x(l)*cl(l2,l1)
              else
                  y(k,j,1)=y(k,j,1)+x(l)*cl(l2,l1)
              end if
          end if
 45       continue
 43   continue
      call getgab(abccos,gabn(1,1,1))
      return
      end

      subroutine getgab(abccos,gab)
      real abccos(6),gab(3,3)
      gab(1,1)=abccos(1)**2
      gab(2,2)=abccos(2)**2
      gab(3,3)=abccos(3)**2
      gab(2,3)=abccos(2)*abccos(3)*abccos(4)
      gab(3,2)=gab(2,3)
      gab(3,1)=abccos(3)*abccos(1)*abccos(5)
      gab(1,3)=gab(3,1)
      gab(1,2)=abccos(1)*abccos(2)*abccos(6)
      gab(2,1)=gab(1,2)
      return
      end

      subroutine getabc(gab,abccos)
      real abccos(6),gab(3,3)
      abccos(1)=sqrt(gab(1,1))
      abccos(2)=sqrt(gab(2,2))
      abccos(3)=sqrt(gab(3,3))
      abccos(4)=gab(2,3)/(abccos(2)*abccos(3))
      abccos(5)=gab(1,3)/(abccos(1)*abccos(3))
      abccos(6)=gab(1,2)/(abccos(1)*abccos(2))
      return
      end

      subroutine wtltcc(x,df)
      real x(0:*),df(0:*)
      include 'premos.inc'
c     parameter (idsmax=2)
      common /ctorms0/ ids
      common /cpwint/ ipt(0:38*idsmax),nlc
      common /cdim/ idm,nde
      common /kwave/ y(3,3,3),vc(3)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
c      character*4 wx(0:50)
      character*5 wx(0:50)
      real bb(3),pivt(3),det
      character*3 ki(3)
      character*6 wabc(6),wy(3,3)
      integer iy(3,3),ig(6),iabc(6)
      integer ipiv(3),indx(6)
      integer js(15),ks(15),nl0(15)
      real yo(3,3)
      save ao,bo,co,cosao,cosbo,cosco,yo,ic
      data js/1,2,3,2,1,1,1,1,1,2,2,2,3,3,3/
      data ks/1,2,3,3,3,2,1,2,3,1,2,3,1,2,3/
      data ki/'k1=','k2=','k3='/
      data ic/0/
      npfx=21+6
      npfn=28+6
      npp=0
C$DOIT ASIS
      do 500 id=1,ids
      if(ids.gt.1) then
          write(6,*) ' data set',id
      end if 
      if(iwl(id).le.8) then
            ie=npfx-1
      else
            ie=npfn-1
      end if
      npp=npp+ie+1
      if(id.eq.1) j0=0
      do 49 i=0,ie
      if(ipt(j0+i).eq.1) then
          idf=df(j0+i)*100000
          write(wx(i),'(i5)') idf
      else
          wx(i)='-----'
      end if
 49   continue
      if(iwl(id).le.8) then
          write(6,'(1h ,a,f10.5,3a,6(f9.5,3a)/1h ,20x,6(f9.5,3a))')
     *       'pb=',(x(j0+j),'(',wx(j),')',j=0,6+6)
          j1=j0+6
          write(6,'(1h ,a,f9.5,3a)') 'as   =',x(j1+7),'(',wx(7+6),')'
          write(6,'(1h ,a,2(f9.5,3a))') 'u,v  =',(x(j1+j),
     *                          '(',wx(j+6),')',j=8,9)
          write(6,'(1h ,a,f9.5,3a)') 'gamma=',x(j1+10),'(',wx(10+6),')'
          write(6,'(1h ,a,3(f9.5,3a))') 'hwhm =',
     *       (x(j1+j),'(',wx(j+6),')',j=11,12)
          write(6,'(1h ,a,f9.5,3a)') 'rhwhm=',x(j1+13),'(',wx(13+6),')'
          write(6,'(1h ,a,f9.5,3a)') 'sgm=',x(j1+14),'(',wx(14+6),')'
          write(6,'(1h ,a,f9.5,3a)') 'pg   =',x(j1+15),'(',wx(15+6),')'
          write(6,'(1h ,a,4(f9.5,3a))') 'pi=',
     *             (x(j1+j),'(',wx(j+6),')',j=16,19)
          write(6,'(1h ,a,f9.5,3a)') 'zps  =',x(j1+20),
     *                  '(',wx(20+6),')'
      else
          write(6,'(1h ,a,f10.5,3a,6(f9.5,3a)/1h ,20x,6(f9.5,3a))')
     *       'pb=',(x(j0+j),'(',wx(j),')',j=0,6+6)
          j1=j0+6
          write(6,'(1h ,a,6(f9.5,3a))') 'si=',(x(j1+j),
     *      '(',wx(j+6),')',j=7,12)
          write(6,'(1h ,a,4(f9.5,3a))') 'gi=',(x(j1+j),
     *                                     '(',wx(j+6),')',j=13,15)
          write(6,'(1h ,a,2(f9.5,3a))') 'ri =',(x(j1+j),
     *                                      '(',wx(j+6),')',j=16,17)
          write(6,'(1h ,a,f9.5,3a))') 'rs1=',x(j1+18),'(',wx(18+6),')'
          write(6,'(1h ,a,f9.5,3a)') 'sgm=',x(j1+19),'(',wx(19+6),')'
          write(6,'(1h ,a,f9.5,3a)') 'pg =',x(j1+20),'(',wx(20+6),')'
          write(6,'(1h ,a,4(f9.5,3a))') 'pi =',
     *            (x(j1+j),'(',wx(j+6),')',j=21,24)
          write(6,'(1h ,a,3(f9.5,3a))') 'cp =',
     *            (x(j1+j),'(',wx(j+6),')',j=25,27)
      end if
      j0=j0+ie+1
 500  continue
      do 44 i=1,3
      do 44 j=1,3
      gab(i,j,1)=gabn(i,j,1)
 44   continue
      call matinv(gab(1,1,1),3,3,bb,0,det,ipiv,indx,pivt)
      a=sqrt(gab(1,1,1))
      b=sqrt(gab(2,2,1))
      c=sqrt(gab(3,3,1))
      cosa=gab(2,3,1)/(b*c)
      cosb=gab(1,3,1)/(a*c)
      cosc=gab(1,2,1)/(a*b)
      ic=ic+1
      if(ic.eq.1) then
          ao=a
          bo=b
          co=c
          cosao=cosa
          cosbo=cosb
          cosco=cosc
          do 50 i=1,nde
          do 50 j=1,3
          yo(j,i)=y(j,i,1)
 50       continue
      end if
      iabc(1)=(a-ao)*1000000
      iabc(2)=(b-bo)*1000000
      iabc(3)=(c-co)*1000000
      iabc(4)=(cosa-cosao)*1000000
      iabc(5)=(cosb-cosbo)*1000000
      iabc(6)=(cosc-cosco)*1000000
      do 51 i=1,nde
      do 51 j=1,3
c         iy(j,k)=0
          iy(j,i)=0
 51   continue
      do 52 i=1,6
          ig(i)=0
 52   continue
      l=npp-1
      do 43 l1=1,nlp
          if(ipt(l+l1).eq.0) go to 43
          do 45 l2=1,ntl(l1)
          l0=il(l2,l1)
          nl0(l0)=nl0(l0)+1
          j=js(l0)
          k=ks(l0)
          if(l0.le.6) then
              ig(l0)=1
          else
              iy(k,j)=1
          end if
 45       continue
 43   continue
      do 46 i=1,6
          if(ig(i).eq.1) then
              write(wabc(i),'(i6)') iabc(i)
          else
              wabc(i)='------'
          end if
 46   continue
      do 47 i=1,nde
      do 47 j=1,3
          if(iy(j,i).eq.1) then
              write(wy(j,i),'(i6)') int((y(j,i,1)-yo(j,i))*1000000)
          else
              wy(j,i)='------'
          end if
 47   continue
      write(6,'(1h ,3(a,f11.6,3a))') 'a =',a,'(',wabc(1),')',
     *       ' b =',b,'(',wabc(2),')',' c =',c,'(',wabc(3),')'
      write(6,'(1h ,3(a,f9.6,3a))') 
     *         'cosa=',cosa,'(',wabc(4),')',
     *         ' cosb=',cosb,'(',wabc(5),')',
     *         ' cosc=',cosc,'(',wabc(6),')'
      do 55 i=1,nde
      write(6,'(1h ,a,3(f11.6,3a))') ki(i),(y(j,i,1),'(',wy(j,i),')',
     *                     j=1,3)
 55   continue
      ao=a
      bo=b
      co=c
      cosao=cosa
      cosbo=cosb
      cosco=cosc
      do 48 i=1,nde
      do 48 j=1,3
      yo(j,i)=y(j,i,1)
 48   continue
      return
      end

      subroutine wtlcsd(x,df,sg)
      real x(0:*),df(0:*),sg(6,*)
      include 'premos.inc'
c     parameter (idsmax=2)
      common /ctorms0/ ids
      common /cpwint/ ipt(0:38*idsmax),nlc
      common /cdim/ idm,nde
      common /kwave/ y(3,3,3),vc(3)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
c      character*4 wx(0:50)
      character*5 wx(0:50)
      real bb(3),pivt(3),det
      character*3 ki(3)
      character*6 wabc(6),wy(3,3)
      integer iy(3,3),ig(6),iabc(6)
      integer ipiv(3),indx(6)
      integer js(15),ks(15),nl0(15)
      real yo(3,3)
      real s1(6,6),s3(6,6),xd(6),yd(3,3)
      save ao,bo,co,cosao,cosbo,cosco,yo,ic
      data js/1,2,3,2,1,1,1,1,1,2,2,2,3,3,3/
      data ks/1,2,3,3,3,2,1,2,3,1,2,3,1,2,3/
      data ki/'k1=','k2=','k3='/
      data ic/0/
      npfx=21+6
      npfn=28+6
      npp=0
      do 500 id=1,ids
      if(ids.gt.1) then
          write(6,*) ' data set',id
      end if
      if(iwl(id).le.8) then
            ie=npfx-1
      else
            ie=npfn-1
      end if
      npp=npp+ie+1
      if(id.eq.1) j0=0
      do 49 i=0,ie
      if(ipt(j0+i).eq.1) then
          idf=df(j0+i)*100000
          write(wx(i),'(i5)') idf
      else
          wx(i)='-----'
      end if
 49   continue
      if(iwl(id).le.8) then
          write(6,'(1h ,a,f10.5,3a,6(f9.5,3a)/1h ,20x,6(f9.5,3a))')
     *       'pb=',(x(j0+j),'(',wx(j),')',j=0,6+6)
          j1=j0+6
          write(6,'(1h ,a,f9.5,3a)') 'as   =',x(j1+7),'(',wx(7+6),')'
          write(6,'(1h ,a,2(f9.5,3a))') 'u,v  =',(x(j1+j),
     *                          '(',wx(j+6),')',j=8,9)
          write(6,'(1h ,a,f9.5,3a)') 'gamma=',x(j1+10),'(',wx(10+6),')'
          write(6,'(1h ,a,2(f9.5,3a))') 'hwhm =',
     *       (x(j1+j),'(',wx(j+6),')',j=11,12)
          write(6,'(1h ,a,f9.5,3a)') 'rhwhm=',x(j1+13),'(',wx(13+6),')'
          write(6,'(1h ,a,f9.5,3a)') 'sgm=',x(j1+14),'(',wx(14+6),')'
          write(6,'(1h ,a,f9.5,3a)') 'pg   =',x(j1+15),
     *                                  '(',wx(15+6),')'
          write(6,'(1h ,a,4(f9.5,3a))') 'pi=',
     *             (x(j1+j),'(',wx(j+6),')',j=16,19)
          write(6,'(1h ,a,f9.5,3a)') 'zps  =',x(j1+20),
     *                  '(',wx(20+6),')'
      else
          write(6,'(1h ,a,f10.5,3a,6(f9.5,3a)/1h ,20x,6(f9.5,3a))')
     *       'pb=',(x(j0+j),'(',wx(j),')',j=0,6+6)
          j1=j0+6
          write(6,'(1h ,a,4(f9.5,3a))') 'si=',(x(j1+j),
     *                                      '(',wx(j+6),')',j=7,12)
          write(6,'(1h ,a,4(f9.5,3a))') 'gi=',(x(j1+j),
     *                                     '(',wx(j+6),')',j=13,15)
          write(6,'(1h ,a,2(f9.5,3a))') 'ri =',(x(j1+j),
     *                                      '(',wx(j+6),')',j=16,17)
          write(6,'(1h ,a,f9.5,3a))') 'rs1=',x(j1+18),'(',wx(18+6),')'
          write(6,'(1h ,a,f9.5,3a)') 'sgm=',x(j1+19),'(',wx(19+6),')'
          write(6,'(1h ,a,f9.5,3a)') 'pg =',x(j1+20),'(',wx(20+6),')'
          write(6,'(1h ,a,4(f9.5,3a))') 'pi =',
     *            (x(j1+j),'(',wx(j+6),')',j=21,24)
          write(6,'(1h ,a,3(f9.5,3a))') 'cp =',
     *            (x(j1+j),'(',wx(j+6),')',j=25,27)
      end if
      j0=j0+ie+1
 500  continue
      ao=a
      bo=b
      co=c
      cosao=cosa
      cosbo=cosb
      cosco=cosc
      do 68 i=1,nde
      do 68 j=1,3
      yo(j,i)=y(j,i,1)
 68   continue
c       standard deviations of lattice constants in direct space
      do 64 i=1,3
      do 64 j=1,3
      gab(i,j,1)=gabn(i,j,1)
 64   continue
      call matinv(gab(1,1,1),3,3,bb,0,det,ipiv,indx,pivt)
      a=sqrt(gab(1,1,1))
      b=sqrt(gab(2,2,1))
      c=sqrt(gab(3,3,1))
      ca=gab(2,3,1)/(b*c)
      cb=gab(1,3,1)/(a*c)
      cc=gab(1,2,1)/(a*b)
      sa=sqrt(1-ca**2)
      sb=sqrt(1-cb**2)
      sc=sqrt(1-cc**2)

      do 10 i=1,6
      do 10 j=1,6
      s1(i,j)=0
      s3(i,j)=0
 10   continue
c     mm : number of independent lattice parameters      
      mm=0
      do 43 j=1,nlp
          do 45 m=1,ntl(j)
          i=il(m,j)
          if(i.le.6) then
              if(m.eq.1) mm=mm+1
              s1(i,j)=cl(m,j)
          end if
 45       continue
 43   continue
c
c      sg: nlp*nlp matrix
c      s1: 6*nlp matrix    da*/dx, db*/dx ......  x: j-th independent param.
c      sg= s1*sg*s1t: 6*6 matrix
c      s3: 6*6 matrix  :   da/da*,da/db*,da/dc*,da/d(cosa*) ....
c           transformation matrix of the standard dev. for as,bs...
c           into a, b, ...
      as=sqrt(gabn(1,1,1))
      bs=sqrt(gabn(2,2,1))
      cs=sqrt(gabn(3,3,1))
      cas=gabn(2,3,1)/(bs*cs)
      cbs=gabn(1,3,1)/(as*cs)
      ccs=gabn(1,2,1)/(as*bs)
      sas=sqrt(1-cas**2)
      sbs=sqrt(1-cbs**2)
      scs=sqrt(1-ccs**2)

      abab=a*b*as*bs
      bcbc=b*c*bs*cs
      acac=a*c*as*cs
      sbc=sbs*scs
      sac=sas*scs
      sab=sas*sbs
      s3(1,1)=-a/as
      s3(2,2)=-b/bs
      s3(3,3)=-c/cs
      s3(1,4)=-a*bcbc*cb*cc
      s3(1,5)=-a*acac*cb
      s3(1,6)=-a*abab*cc
      s3(2,4)=-b*bcbc*ca
      s3(2,5)=-b*acac*ca*cc
      s3(2,6)=-b*abab*cc
      s3(3,4)=-c*bcbc*ca
      s3(3,5)=-c*acac*cb
      s3(3,6)=-c*abab*ca*cb
      s3(4,4)=1/(sa*sbs*scs)
      s3(4,5)=cc/(sb*sbs*scs)
      s3(4,6)=cb/(sc*sbs*scs)
      s3(5,4)=cc/(sa*sas*scs)
      s3(5,5)=1/(sb*sas*scs)
      s3(5,6)=ca/(sc*sas*scs)
      s3(6,4)=cb/(sa*sas*sbs)
      s3(6,5)=ca/(sb*sas*sbs)
      s3(6,6)=1/(sc*sas*sbs)
c       sg : nlp*nlp matrix
      call simtr(s1,6,mm,sg)
c       sg=s1*sg*s1t: 6*6 matrix
      call simtr(s3,6,6,sg)
      do 100 i=1,6
          xd(i)=sqrt(sg(i,i))
 100  continue
c       xd(i): standard deviations of a,b,c,alpha,beta,gamma
      do 70 i=1,6
      if(i.le.3) then
          iabc(i)=xd(i)*1000000
      else
          iabc(i)=xd(i)*1000000
      end if
 70   continue
c       yd(i,j): standard deviation of j-th component in i-th wave vector
      do i=1,nde
         do j=1,3
            iy(j,i)=0
         end do
      end do
      do 72 i=1,6
          ig(i)=0
 72   continue
c     l=ie
      l=npp-1
      do 83 l1=1,nlp
          if(ipt(l+l1).eq.0) go to 83
          do 85 l2=1,ntl(l1)
          l0=il(l2,l1)
          nl0(l0)=nl0(l0)+1
          j=js(l0)
          k=ks(l0)
          if(l0.le.6) then
              ig(l0)=1
          else
              iy(k,j)=1
              yd(k,j)=df(l+l1)*cl(l2,l1)
          end if
 85       continue
 83   continue
      do 86 i=1,6
          if(ig(i).eq.1) then
              write(wabc(i),'(i6)') iabc(i)
          else
              wabc(i)='------'
          end if
 86   continue
      do 87 i=1,nde
      do 87 j=1,3
          if(iy(j,i).eq.1) then
              write(wy(j,i),'(i6)') int(yd(j,i)*1000000)
          else
              wy(j,i)='------'
          end if
 87   continue
      write(6,'(1h ,3(a,f11.6,3a))') 'a =',a,'(',wabc(1),')',
     *       ' b =',b,'(',wabc(2),')',' c =',c,'(',wabc(3),')'
      write(6,'(1h ,3(a,f9.6,3a))') 
     *         'cosa=',cosa,'(',wabc(4),')',
     *         ' cosb=',cosb,'(',wabc(5),')',
     *         ' cosc=',cosc,'(',wabc(6),')'
      write(6,'(1h ,a,3(f11.6,3a))') (ki(i),(y(j,i,1),'(',wy(j,i),')',
     *                     j=1,3),i=1,nde)
      return
      end

      subroutine gets2(s2)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
c      s2: 6*6 matrix  :   dg11*/da*,d11*/db*..  dg11*/d(cosa*)...
      real s2(6,6)
      do 100 i=1,6
      do 100 j=1,6
 100  s2(i,j)=0
      as=sqrt(gabn(1,1,1))
      bs=sqrt(gabn(2,2,1))
      cs=sqrt(gabn(3,3,1))
      cas=gabn(2,3,1)/(bs*cs)
      cbs=gabn(1,3,1)/(as*cs)
      ccs=gabn(1,2,1)/(as*bs)
c     sas=sqrt(1-cas**2)
c     sbs=sqrt(1-cbs**2)
c     scs=sqrt(1-ccs**2)
      s2(1,1)=2*as
      s2(2,2)=2*bs
      s2(3,3)=2*cs
      s2(4,2)=cs*cas
      s2(4,3)=bs*cas
      s2(4,4)=bs*cs
      s2(5,1)=cs*cbs
      s2(5,3)=as*cbs
      s2(5,5)=as*cs
      s2(6,1)=bs*ccs
      s2(6,2)=as*ccs
      s2(6,6)=as*bs
      return
      end

      subroutine simtr(s1,m,n,sg)
      real s1(6,6),sg(6,6),wk(6,6)
c          s1*sg*s1t  s1t: transpose matrix of s1
c       n,m<=6
c       s1: m by n matrix sg: n by n matrix
c       sg is replaced by s1*sg*s1t

      do 10 i=1,m
      do 20 j=1,n
          wk(i,j)=0
          do 30 k=1,n
              wk(i,j)=wk(i,j)+s1(i,k)*sg(k,j)
 30       continue
 20   continue
 10   continue
c       wk: m by n matrix
      do 60 i=1,m
      do 70 j=1,m
          sg(i,j)=0
          do 80 k=1,n
              sg(i,j)=sg(i,j)+wk(i,k)*s1(j,k)
 80       continue
 70   continue
 60   continue
      return
      end

      function vabs1(x,n,gab)
      real x(*),gab(n,*)
      vabs1=0
      do 10 i=1,n
      do 10 j=1,n
      vabs1=vabs1+x(i)*gab(i,j)*x(j)
 10   continue
      vabs1=sqrt(vabs1)
      return
      end

      function vinp1(x,y,n,gab)
c*****inner product of x,y with metric tensor gab
      dimension x(*),y(*),gab(n,*)
      vinp1=0
      do 10 i=1,n
      do 10 j=1,n
 10   vinp1=vinp1+x(i)*gab(i,j)*y(j)
      return
      end

      subroutine nrml(v)
      real v(*)
      absv=sqrt(v(1)**2+v(2)**2+v(3)**2)
      do 100 i=1,3
      v(i)=v(i)/absv
 100  continue
      return
      end

      subroutine vcpy(v1,v2,n)
      real v1(*),v2(*)
      do 100 i=1,n
      v2(i)=v1(i)
 100  continue
      return
      end

      subroutine cnstnt(memmax,iax)
c     calculation of constants
      include 'premos.inc'
c     parameter (idsmax=2)
      common /cnsti/ ix,ib,if,itvr,itst,nds,na8,na9
      common /cnsto/ ix1,ix2,ix3,ix4,ix5,ix6,ix7,ix8,ix9,ix10,ix11,ix12
     *       ,ix13,ix14,ix15,ix16,ix17,ix18,ix19,ix20,ix21,ix22,
     *        ix23,ix24,ix25,ix26,ix27,ix28
      common /cnstt/ jx1,jx2,jx3
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /cdim/ idm,nde
      integer dspmdl,tmpmdl,sctmdl
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      common /ctorms0/ ids
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
c*********************************************************
c    calculation of constants for memory design
c*********************************************************
      pai2=6.28318
      npfx=21+6
      npfn=28+6
      nl=1
      do 10 i=1,nde
 10   nl=nl*ilm(i)
      do 11 i=1,3
 11   nl=nl*ilc(i)
      iii=0
      do 500 id=1,ids
      if(iwl(id).le.8) then
          iii=iii+npfx
      else if(iwl(id).eq.9) then
          iii=iii+npfn
      end if
 500  continue
      nx=ix+ib+if+itvr+itst+nds+nlp+iii
      if(isext.eq.1) nx=nx+2
c      if(itempf.ge.1) it=6
c      if(itempf.lt.1) it=1
      if(abs(itempf).ge.1) it=6
      if(itempf.eq.0) it=1
      if(iphfl.eq.1) it=it+nde*(nde+1)/2
c      ix1=na8
      ix1=na9
      ix2=nx+ix1
      ix3=nx+ix2
      ix4=nx+ix3
      ix5=nx+ix4
      ntwin=abs(itwin)
      if(ntwin.eq.0) ntwin=1
      ix6=nx*ntwin+ix5
      ix7=nx*ntwin+ix6
      ix8=nzc+ix7
      ix9=3*na*nl+ix8
      ix10=it*na*nl+ix9
      ix11=na*nl+ix10
      ix12=nw*na*nl+ix11
      nxd=min0(nx*(nx+1)/2,nxmax*(nxmax+1)/2)
      ix13=nxd+ix12
      ix14=ix13
      ix15=nx+ix14
      ix16=4*nzc+ix15
      ix17=nx+ix16     
      ix18=nw*na*(6+it)+ix17
      if(iand.eq.1) ix18=ix18+nw*na*2
      ix19=nw*na*(6+it)+ix18
      if(iand.eq.1) ix19=ix19+nw*na*2
      ix20=na*(it+4)*nw+ix19
      ix21=na*(it+4)*nw+ix20
      ix22=nw*2*nt+ix21
      ix23=nw*3*nt+ix22
      ix24=nw*nt+ix23
      ix25=nw*nl+ix24
      ix26=nw*nl+ix25
      ix27=nx*nl+ix26
      ix28=nl+ix27
      iax=ix28-memmax-1
      if(iax.gt.0) then
         call quit('increase memmax')
      end if
*******
      jx1=nx
      jx2=na*(it+4)*nw+jx1
      jx3=nw*2*nt+jx2
      return
      end

      subroutine savasf(sctmdl,id)
      integer sctmdl,id
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
      include 'premos.inc'
c     parameter (idsmax=2)
      common /casftd/ ned(idsmax),ascfd(35,20,idsmax),df1d(20,idsmax),
     *        df2d(20,idsmax),iandd(idsmax)
      ned(id)=ne
      do 20 ik=1,ne
           do 30 i=1,35
           ascfd(i,ik,id)=ascf(i,ik)
 30        continue
      if(iand.eq.1) then
           df1d(ik,id)=df1(ik)
           df2d(ik,id)=df2(ik)
      end if
      if(sctmdl.eq.-1) then
           do 31 i=1,35
           ascfd(i,ik+ne,id)=ascf(i,ik+ne)
 31        continue
           if(iand.eq.1) then
               df1d(ik+ne,id)=df1(ik+ne)
               df2d(ik+ne,id)=df2(ik+ne)
           end if
      end if
 20   continue
      iandd(id)=iand
      return
      end

      subroutine getasf(sctmdl,id)
      integer sctmdl,id
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
      include 'premos.inc'
c     parameter (idsmax=2)
      common /casftd/ ned(idsmax),ascfd(35,20,idsmax),df1d(20,idsmax),
     *        df2d(20,idsmax),iandd(idsmax)
      ne=ned(id)
      do 20 ik=1,ne
           do 30 i=1,35
           ascf(i,ik)=ascfd(i,ik,id)
 30        continue
      if(iand.eq.1) then
           df1(ik)=df1d(ik,id)
           df2(ik)=df2d(ik,id)
      end if
      if(sctmdl.eq.-1) then
           do 31 i=1,35
           ascf(i,ik+ne)=ascfd(i,ik+ne,id)
 31        continue
           if(iand.eq.1) then
               df1(ik+ne)=df1d(ik+ne,id)
               df2(ik+ne)=df2d(ik+ne,id)
           end if
      end if
 20   continue
      iand=iandd(id)
      return
      end

      subroutine wx(x,nx,iw)
      dimension x(*),k(14)
      character*4 iw(*)
      common /const/ pai2,j(14)
      include 'premos.inc'
c     parameter (idsmax=2)
      common /ctorms0/ ids
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      character*4 no
      data no/'#'/
      npfx=21+6
      npfn=28+6
      ie=j(14)+1
      do 10 i=1,14
 10   k(i)=j(i)
      do 20 i=1,14,2
      if(k(i).le.k(i+1)) go to 20
      k(i)=0
      k(i+1)=0
 20   continue
      write(6,204) (k(i),i=1,8),(k(i),i=11,14)
      write(6,205) (no,i,x(i),iw(i),i=1,nx)
      write(6,203)
 203  format(1h )
 204  format(1h ,'dspl. (',i3,'-',i3,')',1x,'temp. (',i3,'-',i3,')',
     *    1x,'occup. (',i3,'-',i3,')',1x,'domain (',i3,'-',i3,')',
     *    1x,'scale (',i3,'-',i3,')',
     *    1x,'extinc. (',i3,'-',i3,')')
 205  format((1h ,8(a1,i3,1x,f8.4,a1,1x)))
      return
      end

      subroutine rdiob0(iwght)
      common /cwflag/ iwflag(7)
      common /cdim/ idm,nde
      integer nslct,hm
      integer h4,hd
      common /islct/ hd(3),h4(3,40),nslct
      common /cnsti/ ix,ib,if,itvr,itst,nds,na8,na9
      character*80 fmt
      common /cfmt/ fmt
      common /cfmin/ fmin,wg0,inp,iorf
      common /chkln/ iex(6),hm(6)
      call getinp(inpu)
      call getout(iout)
c      read(inpu,103) nslct,((h4(i,j),i=1,nde),j=1,nslct)
      call freadi('ng=',1,nslct,1)
      do 150 i=1,nslct
          call freadi('h3+i=',nde,h4(1,i),1)
 150  continue
      if(iwflag(3).eq.1) then
           write(iout,'(a,i3,a,20i3)') ' ng=',nslct,' h3+i=',
     *           ((h4(i,j),i=1,nde),j=1,nslct)
      end if
      if(nde.eq.3) go to 211
          j=nde+1
          do 212 k=1,nslct
          do 212 i=j,3
 212      h4(i,k)=0
 211  continue
c      read(inpu,105) fmin,wg0,hm
      call freadr('fmin=',1,fmin,1)
      call freadr('wg0=',1,wg0,0)
      call freadi('hm=',6,hm,0)
      if(iwflag(3).eq.1) then
           write(iout,201) fmin,wg0
      end if
c      read(inpu,100) inp,iorf,fmt
      call freadi('inp=',1,inp,1)
      call freadi('iorf=',1,iorf,0)
      call freadc('format=',1,fmt,0)
*************
c        fixed format for powder
      if(idm.eq.4) then
          fmt='(4i3,2x,i3)'
      else if(idm.eq.5) then
          fmt='(5i3,2x,i3)'
      else if(idm.eq.6) then
          fmt='(6i3,2x,i3)'
      end if
      lfmt=istrln(fmt)
*************
      if(iwflag(3).eq.1) then
           write(iout,202) inp,iorf,fmt(1:lfmt)
      end if
      do 21 i=1,6
      if(hm(i).ne.0) go to 20
 21   continue
      do 22 i=1,3
      j=i+3
      hm(i)=24
 22   hm(j)=10
 20   iex(6)=1
      do 24 i=1,5
      j=6-i
 24   iex(j)=iex(j+1)*(hm(j+1)*2+1)
      return
 201  format(1h ,'fmin=',f12.6,3x,'wg0=',f12.6)
 202  format(1h ,'inp=',i3,3x,'iorf=',i3,3x,'format=',a)
      end

      subroutine rdiob1(iwght)
      common /cwflag/ iwflag(7)
      common /fhkl/ hkln(100),fobs(100),fcal(100),wght(100),im(20),is(2)
     *         ,sf
      common /cdim/ idm,nde
      integer hkln,nslct,ih(6),hm
      integer h4,hd
      common /islct/ hd(3),h4(3,40),nslct
      common /cnsti/ ix,ib,if,itvr,itst,nds,na8,na9
      complex fcal
      character*80 fmt
      common /cfmt/ fmt
      common /cfmin/ fmin,wg0,inp,iorf
      common /chkln/ iex(6),hm(6)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      integer jh(6)
      call getinp(inpu)
      call getout(iout)
      i=0
      is(1)=0
      is(2)=0
      sf=0.0
      iw1=0
      lfmt=istrln(fmt)
      if(inp.ne.5) rewind 3
c****** read at least once even if nds=0 ******
      inde=max(1,nds)
c*******************************
      do 11 inds=1,inde
      ii=0
 10   continue
      i=mod(i,100)
      ih(4)=0
      ih(5)=0
      ih(6)=0

      if(inp.eq.5) read(inpu,fmt(1:lfmt)) (ih(j),j=1,idm)
      if(inp.ne.5) read(3,fmt(1:lfmt)) (ih(j),j=1,idm)
      if(ih(1).eq.999) go to 11
      iabsn=0
      if(abs(ih(1)).gt.hm(1).or.abs(ih(2)).gt.hm(2).or.
     *   abs(ih(3)).gt.hm(3).or.abs(ih(4)).gt.hm(4).or.
     *   abs(ih(5)).gt.hm(5).or.abs(ih(6)).gt.hm(6)) then
            write(6,200) is,hm
            write(6,*) 'ih=',ih,' hm=',hm
            call quit('hklm > hm(i)')
      end if
c         ***** selection is impossible in powder method *****
c      if(nslct.gt.0) then
c           do 500 nd=1,nsub
c           call gethz(zmtrx(1,nd),ih,jh)
c           if(ihslct(jh).eq.1) go to 510
c 500       continue
c           go to 10
c 510       continue
c      end if
c      iabsn=0
c      if(nslct.gt.0) then
c           if(ihslct(ih).ne.1) go to 10
c      end if
      ii=ii+1
      i=i+1
      is(1)=is(1)+1
      hkln(i)=0
      do 17 j=1,6
           hkln(i)=hkln(i)+(ih(j)+hm(j))*iex(j)
 17   continue
      if(iorf.eq.1) fobs(i)=0
      if(iorf.ne.1) fobs(i)=0
c      write(6,*) 'fobs,iwght,fmin,wg,wg0',fobs(i),iwght,fmin,wg,wg0
c      wght(i)=wghtf(fobs(i),iwght,fmin,wg,wg0)
      wght(i)=wghtf(fobs(i),sigmf,iwght,fmin,wg,wg0)
      if(wght(i).ne.0.0) is(2)=is(2)+1
      sf=sf+fobs(i)**2*wght(i)
      if(i.eq.100) iw1=iw1+1
      if(i.eq.100) write(unit=91,rec=iw1) hkln,fobs,wght
      go to 10
 11   im(inds)=ii
      if(i.ne.0) write(unit=91,rec=iw1+1) hkln,fobs,wght
c      if(iwflag(3).eq.1) then
c           write(iout,200) is,hm
c      end if
c     close(unit=91)
c     close(unit=92)
      return
 100  format(2i2,19a4)
 102  format(6f12.6)
 103  format(22i3)
 104  format(18i3)
 105  format(2f12.6,6i3)
 200  format(1h ,'number of total reflections',i5,5x,
     *            'number of reflections used',i5/1h ,
     *            'maximum miller indices',6i5)
      end









